<id>
Internal Links and Anchors
</id>

<version>
0.1b
</version>

<mod info>
This is a mod for YaBB 2.0

This mod allows you to create anchors within your posts, and link to those anchors, so that you can break up your posts/topics into various sections.

To use this mod, you will simply use the following tag to generate the anchor:
[anchor=Testing]This is a test anchor[/anchor]

and the following tags to link to that anchor (as long as you are linking from within the same page):
[link goto=Testing]This is a link that will lead you to the anchor "Testing"[/link]

Unlinke other forum software, where it is virtually impossible to create links that will open in the same window (since the "url" tag always creates a blank target), YaBB makes it easy to open links in the same window by using the "link" tag instead.  This mod makes use of that link tag, and takes it one step further by making it really easy to link to anchors that you've created in your topic.

You might also want to find the following in your Sources/Post.pl (yours may look slightly different, which is why I did not include this alteration in this mod):

		<div style="width: 484px; clear: both;">
		<div style="width: 391px; float:left;">

and replace the widths with values that are approximately 25 to 30 pixels wider (in this example, that would be 514 and 421).

Changelog:
From 0.1a
Added two new UBBC buttons to Post page.
</mod info>

<author>
Curtiss Grymala
</author>

<homepage>
http://dchelp.dcevolution.net/
</homepage>

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
sub DoUBBC {
</search for>

<add after>
	$message =~ s~\[anchor=\s*(.*?)\](.*?)\[/anchor\]~<a name="$1">$2</a>~ig;
	$message =~ s~\[link goto=\s*(.*?)\](.*?)\[/link\]~<a href="#$1">$2</a>~ig;
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
 	$internal_anchor_mod = "Internal Links and Anchors|Curtiss Grymala|Adds 2 new YaBBC tags to allow you to create anchors within your topics, and internal links to those anchors.|0.1b|11-25-2005";
	push (@installed_mods, "$internal_anchor_mod");
</add before>

<edit file>
../../public_html/yabbfiles/ubbc.js
</edit file>

<search for>
function hyperlink() {
	AddSelTextUrl("[url]","[/url]");
}
</search for>

<add after>
function anchor() {
	var anchor_name = prompt("Enter The Anchor Name");
	AddSelTextUrl("[anchor="+anchor_name+"]","[/anchor]");
}

function anchor_link() {
	var link_name = prompt("Enter The Anchor To Which You Are Linking");
	AddSelTextUrl("[link goto="+link_name+"]","[/link]");
}
</add after>

<edit file>
Sources/Post.pl
</edit file>

<search for>
          document.write("<img src='$defaultimagesdir/url.gif' onclick='hyperlink();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'257'}' title='$post_txt{'257'}' border='0' />");
</search for>

<add before>
~;

	# Begin Internal Links and Anchors Code

	fopen(FILE, "$vardir/AnchorSettings.txt");
		$thedata = <FILE>;
	fclose(FILE);
	($anchor_val,$anchor_button) = split (/\|/, $thedata); 
	$anchor_dir .= qq~$modimgurl/anchor_buttons/$anchor_button~;

if($anchor_val eq 'yes') {
$yymain .= qq~          document.write("<img src='$anchor_dir/anchor.gif' onclick='anchor();' "+HAND+" align='top' width='23' height='22' alt='$anchor_txt{'4'}' title='$anchor_txt{'4'}' border='0' />");~;
}

	# End Internal Links and Anchors Code

$yymain .= qq~

</add before>

<search for>
          document.write("<img src='$defaultimagesdir/timestamp.gif' onclick='timestamp($date);' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'245'}' title='$post_txt{'245'}' border='0' /><br />");
</search for>

<add after>
~;
if($anchor_val eq 'yes') {
$yymain .= qq~          document.write("<img src='$anchor_dir/anchor_link.gif' onclick='anchor_link();' "+HAND+" align='top' width='23' height='22' alt='$anchor_txt{'5'}' title='$anchor_txt{'5'}' border='0' />");~;
}
$yymain .= qq~
</add after>

<search for>
LoadLanguage("FA");
</search for>

<add after>
LoadLanguage("Anchors");
</add after>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$anchor_mod = "anchor_mod|Internal Links and Anchor Settings|Edit Your Internal Links and Anchor Settings|";
push (@boardmod_mods, "$anchor_mod");
</add before>

<edit file>
Admin/AdminEdit.pl
</edit file>

<search for>
LoadLanguage("Register");
</search for>

<add after>
LoadLanguage("Anchors");
</add after>

<search for>
	$FORM{'agreement'} =~ s~\n\Z~~;
	fopen(AGREE, ">$langdir/$agreementlanguage/agreement.txt");
	print AGREE $FORM{'agreement'};
	fclose(AGREE);
	$yySetLocation = qq~$adminurl~;
	&redirectexit;
}
</search for>

<add after>
sub ModifyAnchorSettings {
	&is_admin_or_gmod;
	my( $anchorsettings, $line );
fopen(ANCHORSETTINGS, "$vardir/AnchorSettings.txt");
	$thedata = <ANCHORSETTINGS>;
fclose(ANCHORSETTINGS);
($anchor_val,$anchor_button) = split (/\|/, $thedata);
$yymain .= qq~
<table>
  <tr valign="top">
    <td class="titlebg" align="left" colspan="2">
	<form action="$adminurl?action=anchor2" method="post">
      <img src="$imagesdir/xx.gif" alt="$anchor_txt{'1'}" border="0" />
      <b>$anchor_txt{'1'}</b>
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      <b>$anchor_txt{'6'}</b>
    </td>
    <td class="windowbg3" align="left">
      <input type="checkbox" name="anchor_val" value="yes"~;
if($anchor_val eq 'yes') {
$yymain .= qq~ checked~;
}
$yymain .= qq~ />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      $anchor_txt{'2'}
    </td>
    <td class="windowbg3" align="left">
      <table>
	<tr>
		<td>
			<input type="radio" name="anchor_button" value="blue"~;
if($anchor_button eq 'blue') {
$yymain .= qq~ checked~;
}
$yymain .= qq~ />
		</td>
		<td>
			<img src="$modimgurl/anchor_buttons/blue/anchor.gif" />
			<img src="$modimgurl/anchor_buttons/blue/anchor_link.gif" />
		</td>
	</tr>
	<tr>
		<td>
			<input type="radio" name="anchor_button" value="bronze"~;
if($anchor_button eq 'bronze') {
$yymain .= qq~ checked~;
}
$yymain .= qq~ />
		</td>
		<td>
			<img src="$modimgurl/anchor_buttons/bronze/anchor.gif" />
			<img src="$modimgurl/anchor_buttons/bronze/anchor_link.gif" />
		</td>
	</tr>
	<tr>
		<td>
			<input type="radio" name="anchor_button" value="gold"~;
if($anchor_button eq 'gold') {
$yymain .= qq~ checked~;
}
$yymain .= qq~ />
		</td>
		<td>
			<img src="$modimgurl/anchor_buttons/gold/anchor.gif" />
			<img src="$modimgurl/anchor_buttons/gold/anchor_link.gif" />
		</td>
	</tr>
	<tr>
		<td>
			<input type="radio" name="anchor_button" value="silver"~;
if($anchor_button eq 'silver') {
$yymain .= qq~ checked~;
}
$yymain .= qq~ />
		</td>
		<td>
			<img src="$modimgurl/anchor_buttons/silver/anchor.gif" />
			<img src="$modimgurl/anchor_buttons/silver/anchor_link.gif" />
		</td>
	</tr>
</table>
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg" align="right" colspan="2">
      <input type="submit" value="$anchor_txt{'3'}" name="AnchorSubmit" />
      </form>
    </td>
  </tr>
</table>
~;

	$yytitle = "$anchor_txt{'1'}";
	$action_area = "anchor_mod";
	&AdminTemplate;
	exit;
}

sub ModifyAnchorSettings2 {
	&is_admin_or_gmod;
	$anchor_button = $FORM{'anchor_button'};
	$anchor_val = $FORM{'anchor_val'};
	$anchor_set = "$anchor_val|$anchor_button";
fopen(ANCHORSETTINGS, ">$vardir/AnchorSettings.txt");
	print ANCHORSETTINGS $anchor_set;
fclose(ANCHOR); 
 	$yySetLocation = qq~$adminurl~;
	&redirectexit;
}
</add after>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'modagreement2',"AdminEdit.pl&ModifyAgreement2",
</search for>

<add after>
'anchor_mod',"AdminEdit.pl&ModifyAnchorSettings",
'anchor2',"AdminEdit.pl&ModifyAnchorSettings2",
</add after>